
#ifndef AUDIOMIXER_H
#define AUDIOMIXER_H

#include <windows.h>
#include "AudioOutputLine.h"
#include "Processor.h"
#include "ProcessorBus.h"
#include "PlugIn.h"
#include "AudioOutputDevice.h"

const INT32 MAX_LINES = 10;

class AudioMixer : public Processor
{

    friend class AudioOutputLine;

    public:
        AudioMixer();
        AudioMixer(ProcessorBus* pb);
        void init(ProcessorBus* pb);
        void reset();
        INT32 tick();
        INT32 getClockSpeed();
        void createLine(AudioOutputLine** line);
        void releaseLine(AudioOutputLine** line);
        void changePlugIn(PlugIn* plugIn);

    private:
        ProcessorBus*      processorBus;
        AudioOutputLine*   lines[MAX_LINES];
        INT32              lineCount;
        PlugIn*            plugIn;
        AudioOutputDevice* aod;
        BOOL               highQualityMixing;

};

#endif
