
#ifndef EMULATIONDIRECTOR_H
#define EMULATIONDIRECTOR_H

#include "InputDevice.h"
#include "InputSignal.h"
#include "Processor.h"
#include "Peripheral.h"
#include "Memory.h"
#include "PlugIn.h"

class Intellivision;

class EmulationDirector : public Processor, public Peripheral
{

    public:
        EmulationDirector();
        void init(Intellivision* inty);
        INT32 getProcessorCount();
        void getProcessor(INT32 i, Processor** p);
        INT32 getMemoryCount();
        void getMemory(INT32 i, Memory** m);
        INT32 getClockSpeed();
        void reset();
        INT32 tick();
        void changePlugIn(PlugIn* plugIn);
        void setNetworkGame(BOOL b);
        void setPlayerOneRemote(BOOL b);
        void setPlayerTwoRemote(BOOL b);

/*
        INT32 getControlCount();
        String getControlDescription(INT32 controlNum);
        void setControlInputSignal(INT32 controlNum, InputSignal inputSignal);
        InputSignal getControlInputSignal(INT32 controlNum);
        void save(SaveOutputStream sos);
        void load(LoadInputStream lis);
*/

    private:
        Intellivision* inty;
        BOOL           networkGame;
        BOOL           player1Remote;
        BOOL           player2Remote;
        InputDevice*   inputDevice;
        InputSignal*   inputSignals[6];
        BOOL           buttonPressed[6];
        PlugIn*        plugIn;

};

#endif
