
#ifndef GRAM_H
#define GRAM_H

#include "Memory.h"

class GRAM : public Memory
{

    public:
        GRAM();
        void init(INT32 size, INT32 location, INT32 bitWidth);
        ~GRAM();
        void reset();
        INT32 getLocation();
        INT32 peek(INT32 location);
        void poke(INT32 location, INT32 value);
        void markClean();
        BOOL isDirty();
        BOOL isDirty(INT32 location);
        INT32 getSize();
/*
        void save(SaveOutputStream os) throws IOException;
        void load(LoadInputStream is) throws IOException;
*/

    private:
        INT32       size;
        INT32       location;
        INT32       bitWidth;
        INT32       trimmer;
        INT32*      image;
        BOOL*     dirtyBytes;
        BOOL      dirtyRAM;

};

#endif

