
#ifndef PROCESSORBUS_H
#define PROCESSORBUS_H

#include <windows.h>
#include "Processor.h"
#include "PlugIn.h"

class AudioMixer;
class AudioOutputLine;

class ProcessorBus
{

    friend class AudioMixer;
    friend class AudioOutputLine;

    public:
        ProcessorBus();
        void reset();
        void addProcessor(Processor* p);
        void removeProcessor(Processor* p);
        void run();
        void stop();
        void setPaused(BOOL paused);
        BOOL isPaused();
        void changePlugIn(PlugIn* plugIn);
/*
        void save(SaveOutputStream sos) throws IOException;
        void load(LoadInputStream lis) throws IOException;
*/

    private:
        BOOL        running;
        BOOL        paused;
        Processor*  processors[15];
        INT64       processorTickFactors[15];
        INT64       processorTicks[15];
        BOOL        processorsIdle[15];
        INT32       processorCount;
        PlugIn*     plugIn;
        INT32       currentProcessor;
        UINT64      tickDelta;
        INT64       clock;
        BOOL        deltaPass;

};

UINT64 lcm(UINT64 a, UINT64 b);
UINT64 gcd(UINT64 m, UINT64 n);

#endif
