
#ifndef ROM_H
#define ROM_H

#include <windows.h>
#include "Memory.h"

class ROM : public Memory
{

    public:
        ROM();
        ROM(INT32 size, INT32 location);
        void init(INT32 size, INT32 location);
        ~ROM();
        void loadImage(INT32* image);
        void reset();
        INT32 getLocation();
        INT32 peek(INT32 location);
        void poke(INT32 location, INT32 value);
        INT32 getSize();
        static void loadROMImage(INT32** romImage, INT32* size,
                const CHAR* resourceName, BOOL is16bit);
        static void loadROM(ROM** rom, INT32 location, const CHAR* resourceName,
                BOOL is16bit);
/*
        void save(SaveOutputStream sos);
        void load(LoadInputStream sos);
*/


    private:
        INT32*  image;
        INT32   size;
        INT32   location;

};


#endif

