
#include <iostream>
#include "BankSwitchedROM.h"

BankSwitchedROM::BankSwitchedROM()
    : image(NULL)
{}

BankSwitchedROM::BankSwitchedROM(INT32 size, INT32 page,
        INT32 location)
    : image(NULL)
{
    init(size, page, location);
}

BankSwitchedROM::~BankSwitchedROM()
{
    if (image != NULL)
        delete[] image;
}

void BankSwitchedROM::init(INT32 size, INT32 page, INT32 location)
{
    this->image = new INT32[size];
    this->size = size;
    this->imagePage = page;
    this->location = location;
    this->currentPage = 0;
    this->pageChangeValue = (location & 0xF000) | 0x0A50;
}

void BankSwitchedROM::loadImage(INT32* image)
{
    memcpy(this->image, image, size*sizeof(INT32));
}

void BankSwitchedROM::reset() {
    currentPage = 0;
}

INT32 BankSwitchedROM::getSize() {
    return size;
}

INT32 BankSwitchedROM::getLocation() {
    return location;
}

void BankSwitchedROM::poke(INT32 location, INT32 value) {
    if (((location - this->location) == 0x0FFF) &&
            ((value & 0xFFF0) == pageChangeValue))
        currentPage = (value & 0x000F);
}

INT32 BankSwitchedROM::peek(INT32 location) {
    return (this->currentPage == this->imagePage
            ? this->image[location - this->location] : UNMAPPED_PEEK);
}

/*
void BankSwitchedROM::save(SaveOutputStream sos) throws IOException {
    sos.writeInt(currentPage);
}

void BankSwitchedROM::load(LoadInputStream lis) throws IOException {
    currentPage = lis.readInt(0, 15);
}
*/

