
#ifndef ECSKEYBOARD_H
#define ECSKEYBOARD_H

#include "IODevice.h"
#include "InputDevice.h"
#include "InputSignal.h"

class EmulationDirector;

class ECSKeyboard : public IODevice
{

    friend class EmulationDirector;

    public:
        ECSKeyboard();
        void setInputDevice(InputDevice* inputDevice);
        void reset();
        void poll();
        INT32 getInputValue();
        void setOutputValue(INT32 value);
        INT32 getControlCount();
        void setControlInputSignal(INT32 controlNum, InputSignal* inputSignal);
        void getControlInputSignal(INT32 controlNum, InputSignal** inputSignal);
        void getControlDescription(INT32 controlNum, CHAR* desc);

    private:
        INT32        rowsToScan;
        InputDevice* inputDevice;
        InputSignal* inputSignals[64];
        INT32        rowInputValues[8];

        static const INT32 mappings[48];

/*
    private final static String[] descriptionKeys = {
            "InputECSLeft",
            "InputECSComma",
            "InputECSN",
            "InputECSV",
            "InputECSX",
            "InputECSSpace",
            "InputECSPeriod",
            "InputECSM",
            "InputECSB",
            "InputECSC",
            "InputECSZ",
            "InputECSDown",
            "InputECSSemiColon",
            "InputECSK",
            "InputECSH",
            "InputECSF",
            "InputECSS",
            "InputECSUp",
            "InputECSP",
            "InputECSI",
            "InputECSY",
            "InputECSR",
            "InputECSW",
            "InputECSQ",
            "InputECSEscape",
            "InputECS9",
            "InputECS7",
            "InputECS5",
            "InputECS3",
            "InputECS1",
            "InputECS0",
            "InputECS8",
            "InputECS6",        
            "InputECS4",
            "InputECS2",
            "InputECSRight",
            "InputECSEnter",    
            "InputECSO",
            "InputECSU",
            "InputECST",
            "InputECSE",
            "InputECSControl",
            "InputECSL",
            "InputECSJ",
            "InputECSG",
            "InputECSD",
            "InputECSA",
            "InputECSShift",
        };
*/
};

#endif

